package com.gic.store.service.impl;

import com.gic.store.dao.mapper.TabStoreMapper;
import com.gic.store.dto.StoreDTO;
import com.gic.store.entity.TabStore;
import com.gic.store.service.StoreService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;

/**
 * @author zhiwj
 * @date 2019/6/27
 */
@Service
public class StoreServiceImpl implements StoreService {

    @Autowired
    TabStoreMapper tabStoreMapper;

    @Override
    public Integer save(StoreDTO storeDTO) {
        TabStore tabStore = new TabStore();
        tabStore.setEnterpriseId(storeDTO.getEnterpriseId());
        tabStore.setStoreName(storeDTO.getStoreName());
        tabStore.setStoreCode(storeDTO.getStoreCode());
        tabStore.setRegionId(storeDTO.getRegionId());
        tabStore.setConactsPhone(storeDTO.getConactsPhone());
        tabStore.setAddress(storeDTO.getAddress());
        tabStore.setBrandIds(storeDTO.getBrandIds());
        tabStore.setAreaId(storeDTO.getAreaId());
        tabStore.setLongitude(storeDTO.getLongitude());
        tabStore.setLatitude(storeDTO.getLatitude());
        // TODO 这里要判断一下总量
        tabStore.setOverflowStatus(0);

        tabStore.setStatus(storeDTO.getStatus());
        tabStore.setErpStatus(storeDTO.getErpStatus());
        tabStore.setStoreType(storeDTO.getStoreType());
        tabStore.setStoreGroupId(storeDTO.getStoreGroupId());
        tabStore.setCreateTime(new Date());
        return tabStoreMapper.insertSelective(tabStore);
    }

    @Override
    public Integer update(StoreDTO copy) {
        TabStore tabStore = new TabStore();
        tabStore.setStoreId(copy.getStoreId());
        tabStore.setEnterpriseId(copy.getEnterpriseId());
        tabStore.setStoreName(copy.getStoreName());
        tabStore.setRegionId(copy.getRegionId());
        tabStore.setConactsPhone(copy.getConactsPhone());
        tabStore.setAddress(copy.getAddress());
        tabStore.setBrandIds(copy.getBrandIds());
        tabStore.setAreaId(copy.getAreaId());
        tabStore.setLongitude(copy.getLongitude());
        tabStore.setLatitude(copy.getLatitude());
        tabStore.setStatus(copy.getStatus());
        tabStore.setErpStatus(copy.getErpStatus());
        tabStore.setStoreType(copy.getStoreType());
        tabStore.setStoreGroupId(copy.getStoreGroupId());
        // TODO 这里要判断一下总量
        tabStore.setOverflowStatus(0);

        return tabStoreMapper.updateByPrimaryKeySelective(tabStore);
    }

    @Override
    public Integer countByGroupId(Integer storeGroupId) {
        TabStore tabStore = new TabStore();
        tabStore.setStoreGroupId(storeGroupId);
        return tabStoreMapper.countBySelective(tabStore);
    }

    @Override
    public Integer updateGroupId(Integer oldStoreGroupId, Integer newStoreGroupId) {
        return tabStoreMapper.updateGroupId(oldStoreGroupId, newStoreGroupId);
    }

    @Override
    public TabStore getById(Integer storeId) {
        return tabStoreMapper.selectByPrimaryKey(storeId);
    }

    @Override
    public Integer countByBrandId(Integer brandId) {
        return tabStoreMapper.countByBrandId(brandId);
    }
}
